package jp.co.y_net.amm.dao;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Example;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Component;


@Component("pwtcktDao")
public class PwtcktDao extends AbstractDao {
    
    /* 参照形処理 ------------------------------------------------------------------------------------------------ */
    /** ユニークキーを使用した取得 */
    public List<Pwtckt> get(Pwtckt cnd) {
        if(cnd != null) {
            cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        }
        HibernateTemplate hibernateTemplate = getHibernateTemplate();
        DetachedCriteria dc = DetachedCriteria.forClass(Pwtckt.class);
        dc.add(Example.create(cnd));
        @SuppressWarnings("unchecked")
        List<Pwtckt> list = (List<Pwtckt>) hibernateTemplate.findByCriteria(dc);
        hibernateTemplate.clear();
        return list;
    }
    /** TODO 全件取得(論理削除除外) 必要になったら実装 */
    
    /** TODO 条件付き取得(論理削除除外) 必要になったら実装*/
    
    /* 更新系処理 ------------------------------------------------------------------------------------------------ */
    private static final String ENTITYNAME = "Pwtckt";
    private static final String PKEYNAME = "pwtcktid";
    /**
     * 登録処理
     * ・必要なカラムを自動採番する
     * ・共通処理を実施する。
     * @param item
     */
    public void add(Pwtckt item, Integer updateusrid) {
        /* 自動採番 */
        item.setPwtcktid(getNextId(ENTITYNAME, PKEYNAME));
        /* Insert実施 */
        super.add(item, updateusrid);
    }
    public void update(Pwtckt item, Integer updateusrid) {
        super.update(item, updateusrid);
    }
    public void removeLogical(Pwtckt item, Integer updateusrid) {
        super.removeLogical(item, updateusrid);
    }

}
